

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.12. in_values &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.13. math_abs" href="math_abs.html" />
    <link rel="prev" title="7.15.11. in_records" href="in_records.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/in_values.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="math_abs.html" title="7.15.13. math_abs"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="in_records.html" title="7.15.11. in_records"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.12. </span><code class="docutils literal notranslate"><span class="pre">in_values</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="in-values">
<h1><span class="section-number">7.15.12. </span><code class="docutils literal notranslate"><span class="pre">in_values</span></code><a class="headerlink" href="#in-values" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.12.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.7.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">in_values</span></code> enables you to simplify the query which uses multiple <code class="docutils literal notranslate"><span class="pre">OR</span></code> or <code class="docutils literal notranslate"><span class="pre">==</span></code>. It is recommended to use this function in point of view about performance improvements in such a case.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.12.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">in_values</span></code> requires two or more arguments - <code class="docutils literal notranslate"><span class="pre">target_value</span></code> and multiple <code class="docutils literal notranslate"><span class="pre">value</span></code>.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>in_values(target_value, value1, ..., valueN)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.12.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is a schema definition and sample data.</p>
<p>Sample schema:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Tags TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Memos TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Memos tag COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Tags memos_tag COLUMN_INDEX Memos tag
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Sample data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Memos
[
{&quot;_key&quot;: &quot;Groonga is fast&quot;,          &quot;tag&quot;: &quot;groonga&quot;},
{&quot;_key&quot;: &quot;Mroonga is fast&quot;,          &quot;tag&quot;: &quot;mroonga&quot;},
{&quot;_key&quot;: &quot;Rroonga is fast&quot;,          &quot;tag&quot;: &quot;rroonga&quot;},
{&quot;_key&quot;: &quot;Droonga is fast&quot;,          &quot;tag&quot;: &quot;droonga&quot;},
{&quot;_key&quot;: &quot;Groonga is a HTTP server&quot;, &quot;tag&quot;: &quot;groonga&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p>Here is the simple usage of <code class="docutils literal notranslate"><span class="pre">in_values</span></code> function which selects the records - the value of <code class="docutils literal notranslate"><span class="pre">tag</span></code> column is “groonga” or “mroonga” or “droonga”.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Memos --output_columns _key,tag --filter &#39;in_values(tag, &quot;groonga&quot;, &quot;mroonga&quot;, &quot;droonga&quot;)&#39; --sort_keys _id
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         4
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;tag&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;Groonga is fast&quot;,
#         &quot;groonga&quot;
#       ],
#       [
#         &quot;Mroonga is fast&quot;,
#         &quot;mroonga&quot;
#       ],
#       [
#         &quot;Droonga is fast&quot;,
#         &quot;droonga&quot;
#       ],
#       [
#         &quot;Groonga is a HTTP server&quot;,
#         &quot;groonga&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>When executing the above query, you can get the records except “rroonga” because “rroonga” is not specified as value in <code class="docutils literal notranslate"><span class="pre">in_values</span></code>.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.12.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>There are two or more required parameter, <code class="docutils literal notranslate"><span class="pre">target_value</span></code> and multiple <code class="docutils literal notranslate"><span class="pre">value</span></code>.</p>
<div class="section" id="target-value">
<h3><span class="section-number">7.15.12.4.1. </span><code class="docutils literal notranslate"><span class="pre">target_value</span></code><a class="headerlink" href="#target-value" title="Permalink to this headline">¶</a></h3>
<p>Specifies a column of the table that is specified by <code class="docutils literal notranslate"><span class="pre">table</span></code> parameter in <code class="docutils literal notranslate"><span class="pre">select</span></code>.</p>
</div>
<div class="section" id="value">
<h3><span class="section-number">7.15.12.4.2. </span><code class="docutils literal notranslate"><span class="pre">value</span></code><a class="headerlink" href="#value" title="Permalink to this headline">¶</a></h3>
<p>Specifies a value of the column which you want to select.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.12.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">in_values</span></code> returns whether the value of column exists in specified the value of parameters or not.</p>
<p>If record is matched to specified the value of parameters, it returns true. Otherwise, it returns false.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.12. <code class="docutils literal notranslate"><span class="pre">in_values</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.12.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.12.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.12.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.12.4. Parameters</a><ul>
<li><a class="reference internal" href="#target-value">7.15.12.4.1. <code class="docutils literal notranslate"><span class="pre">target_value</span></code></a></li>
<li><a class="reference internal" href="#value">7.15.12.4.2. <code class="docutils literal notranslate"><span class="pre">value</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.12.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="in_records.html"
                        title="previous chapter"><span class="section-number">7.15.11. </span><code class="docutils literal notranslate"><span class="pre">in_records</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="math_abs.html"
                        title="next chapter"><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="math_abs.html" title="7.15.13. math_abs"
             >next</a> |</li>
        <li class="right" >
          <a href="in_records.html" title="7.15.11. in_records"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.12. </span><code class="docutils literal notranslate"><span class="pre">in_values</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>